import debug from 'debug';
import winPath from './winPath';
import { PLACEHOLDER_IMPORT } from './constants';

// 参考：
// https://github.com/vuejs/vue-cli/blob/next/packages/%40vue/cli-service/lib/PluginAPI.js

class PluginAPI {
  constructor(id, service) {
    this.id = id;
    this.service = service;
    this.utils = {
      winPath,
      debug: debug(`umi-plugin: ${id}`),
    };
    this.placeholder = {
      IMPORT: PLACEHOLDER_IMPORT,
    };
  }

  register(key, fn) {
    if (!this.service.pluginMethods[key]) {
      this.service.pluginMethods[key] = [];
    }
    this.service.pluginMethods[key].push({
      fn,
    });
  }

  modifyWebpackConfig(fn) {
    this.register('modifyWebpackConfig', fn);
  }
}

export default PluginAPI;
